# -sam k (commport5@lucidx.com)

use POSIX qw(strftime);
use pdump::Sniff;

sub check_all {
 my ($alla,$call,$nite,$headers,$df,$trgt,@nda,@ndb,$totl,@ints,$vers,$ihl,$tos,$tot,$id,$frg,$ttl,$pro,$chc,$saddr,$daddr,$sport,$dport,$seq,$aseq,$dof,$res1,$res2,$urg,$ack,$psh,$rst,$syn,$fin,$win,$chk,$data,$len,$mtu,$iid,$type,$code,$gateway,$unu) = ($offset_all, $_[2], 0);
 @sffp = grep { /^[^(#|\s+|\n)]/ } split(/\n/, $sphn);
 $time = timem();
 $untm = time();
 $time =~ s/^.*?\.(.*?)$/$1/;
 $packet_all->bset($call, $alla);
 $prt = $packet_all->proto;
 $prt =~ /^(.{1})/;
 $prot = uc($1);
 $proto = $prt;
 if ($prt =~ /tcp/i) {
  ($vers,$ihl,$tos,$tot,$id,$frg,$ttl,$pro,$chc,$saddr,$daddr,$sport,$dport,$seq,$aseq,$dof,$res1,$res2,$urg,$ack,$psh,$rst,$syn,$fin,$win,$chk,$data) =
  $packet_all->get({ip=>['version','ihl','tos','tot_len','id','frag_off','ttl','protocol','check','saddr','daddr'],tcp=>[
  'source','dest','seq','ack_seq','doff','res1','res2','urg','ack','psh','rst','syn','fin','window','check','data']});
 }
 elsif ($prt =~ /udp/i) {
  ($vers,$ihl,$tos,$tot,$id,$frg,$ttl,$pro,$chc,$saddr,$daddr,$sport,$dport,$len,$chk,$data) =
  $packet_udp->get({ip=>['version','ihl','tos','tot_len','id','frag_off','ttl','protocol','check','saddr','daddr'],
  udp=>['source','dest','len','check','data']});
 }
 elsif ($prt =~ /icmp/i) {
  ($vers,$ihl,$tos,$tot,$iid,$frg,$ttl,$pro,$chc,$saddr,$daddr,$type,$code,$chk,$gateway,$id,$seq,$unu,$mtu,$data) =
  $packet_icmp->get({ip=>['version','ihl','tos','tot_len','id','frag_off','ttl','protocol','check','saddr','daddr'],
  icmp=>['type','code','check','gateway','id','sequence','unused','mtu','data']});
 }
 if ($urg) {
  $headers .= "U";
 }
 if ($psh) {
  $headers .= "P";
 }
 if ($rst) {
  $headers .= "R";
 }
 if ($syn) {
  $headers .= "S";
 }
 if ($fin) {
  $headers .= "F";
 }
 unless ($headers) {
  $headers = ".";
 }
 if ($frg == 16384) {
  $df = " (DF)";
 }
 $seq =~ s/^-//;
 if ($dmth) {
  $flags = unpack("B8", substr($call, $allo+20+13, 1));
  substr($flags, 6, 1) == '1' || substr($flags, 7, 1) == '1';
  %pd = &getpckt($allo);
  if ($nons) {
   $sname = $pd{'saddr'};
   $dname = $pd{'daddr'};
   $stest = $sname;
   $dtest = $dname;
  }
  else {
   $sname = $pd{'shost'};
   $dname = $pd{'dhost'};
   $stest = $pd{'saddr'};
   $dtest = $pd{'daddr'};
  }
 }
 else {
  if ($nons) {
   $sname = &ip2dot($saddr);
   $dname = &ip2dot($daddr);
   $stest = $sname;
   $dtest = $dname;
  }
  else {
   $sname = &ip2name($saddr);
   $dname = &ip2name($daddr);
   $stest = &ip2dot($saddr);
   $dtest = &ip2dot($daddr);
  }
 }
 unless ($nosv) {
  @sserv = &port2serv($sport, $proto);
  @dserv = &port2serv($dport, $proto);
 }
 if ($sserv[0]) {
  $stype = $sserv[0];
 }
 else {
  $stype = $sport;
 }
 if ($dserv[0]) {
  $dtype = $dserv[0];
 }
 else {
  $dtype = $dport;
 }
 if ($pgnr) {
  unless ($pnrc) {
   if ($sport =~ /$prgx/ or $dport =~ /$prgx/ or $stype =~ /$prgx/ or $dtype =~ /$prgx/) {
    $nite++;
   }
  }
  else {
   if ($sport =~ /$prgx/i or $dport =~ /$prgx/i or $stype =~ /$prgx/i or $dtype =~ /$prgx/i) {
    $nite++;
   }
  }
 }
 if ($ignr) {
  unless ($gnrc) {
   if ($sname =~ /$regx/ or $dname =~ /$regx/ or $stest =~ /$regx/ or $dtest =~ /$regx/) {
    $nite++;
   }
  }
  else {
   if ($sname =~ /$regx/i or $dname =~ /$regx/i or $stest =~ /$regx/i or $dtest =~ /$regx/i) {
    $nite++;
   }
  }
 }
 if ($nofl and !$fl) {
  $dname =~ s/^([^\.]+)\..*?$/$1/;
  $sname =~ s/^([^\.]+)\..*?$/$1/;
 }
 unless ($nite) {
  $top++;
  if ($ngrp) {
   if ($data) {
    if ($ack) {
     $hdrs = "[A" . $headers . "]";
    }
    else {
     $hdrs = "[" . $headers . "]";
    }
    unless ($ngrx) {
     if ($ngrc) {
      if ($ngra) {
       unless ($ansi) {
        if ($strn) {
         &format;
        }
        else {
         print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
        }
       }
       else {
        if ($strn) {
         &format;
        }
        else {
         print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
        }
       }
      }
      else {
       if ($data =~ /$ngrr/i) {
        unless ($ansi) {
         if ($strn) {
          &format;
         }
         else {
          print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
         }
        }
        else {
         if ($strn) {
          &format;
         }
         else {
          print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
         }
        }
       }
       else {
        unless ($strn) {
         print "#";
        }
       }
      }
     }
     else {
      if ($ngra) {
       unless ($ansi) {
        if ($strn) {
         &format;
        }
        else {
         print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
        }
       }
       else {
        if ($strn) {
         &format;
        }
        else {
         print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
        }
       }
      }
      else {
       if ($data =~ /$ngrr/) {
        unless ($ansi) {
         if ($strn) {
          &format;
         }
         else {
          print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
         }
        }
        else {
         if ($strn) {
          &format;
         }
         else {
          print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
         }
        }
       }
       else {
        unless ($strn) {
         print "#";
        } 
       }
      }
     }
    }
    else {
     if ($ngrc) {
      if ($ngra) {
       unless ($ansi) {
        if ($strn) {
         &format;
        }
        else {
         print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
        }
       }
       else {
        if ($strn) {
         &format;
        }
        else {
         print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
        }
       }
      }
      else {
       if ($data !~ /$ngrr/i) {
        unless ($ansi) {
         if ($strn) {
          &format;
         }
         else {
          print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
         }
        }
        else {
         if ($strn) {
          &format;
         }
         else {
          print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
         }
        }
       }
       else {
        unless ($strn) {
         print "#";
        }
       }
      }
     }
     else {
      if ($ngra) {
       unless ($ansi) {
        if ($strn) {
         &format;
        }
        else {
         print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
        }
       } 
       else {
        if ($strn) {
         &format;
        }
        else {
         print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
        }
       }
      }
      else {
       if ($data !~ /$ngrr/) {
        unless ($ansi) {
         if ($strn) {
          &format;
         }
         else {
          print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
         }
        }
        else {
         if ($strn) {
          &format;
         }
         else {
          print "\n$prot $stest:$sport -> $dtest:$dport $hdrs\n$data..\n";
         }
        }
       }
       else {
        unless ($strn) {
         print "#";
        }
       }
      }
     }
    }
   }
  }
  elsif ($spfp) {
#   $nvlu = "$win:$ttl:";
#   if ($frg == 16384) {
#    $nvlu .= "1";
#   }
#   else {
#    $nvlu .= "0";
#   }
#   print "$nvlu\t$stest:$sport\t$dtest:$dport\n";
#   if ($vlus{$nvlu} and !$done{$dtest}) {
#    if ($stest ne $ip) {
#     print "$dtest\t$dport\t$vlus{$nvlu}\n";
#     $done{$dtest} = 1;
#    }
#   }
   unless ($done{$stest}) {
    unless ($stest eq $ip) {
     foreach $trgt (@sffp) {
      @ints = split(/:/, $trgt);
      if (hex($ints[0]) eq $win) {
#      if ($ints[1] eq $ttl) {
       if ($ints[2] == 0 and $frg != 16384 or $ints[2] == 1 and $frg == 16384) {
        print "$stest\t$sport\t$ints[3]\n";
        $done{$stest} = 1;
        last;
       }
      }
     }
    }
   }
#   foreach $trgt (@sffp) {
#    @ints = split(/:/, $trgt);
#    if (hex($ints[0]) eq $win) {
#     if ($ints[1] eq $ttl) {
#      if ($ints[2] == 0 and $frg != 16384 or $ints[2] == 1 and $frg == 16384) {
#       unless ($done{$dtest}) {
#        print "$dtest\t$dport\t$ints[3]\n";
#        print "$win:$ttl\n";
#        last;
#       }
#       $done{$dtest} = 1;
#      }
#     }
#    }
#   }
  }
  elsif ($strn) {
   $tm = strftime "%H:%M:%S", localtime;
   $tm .= ".$time";
   $str = $strg;
   $nstrg = $strg;
   %string = (
	"saddr", $stest,
	"daddr", $dtest,
	"source", $sname,
	"dest", $dname,
	"shost", $sname,
	"dhost", $dname,
	"sserv", $stype,
	"dserv", $dtype,
	"version", $vers,
	"ihl", $ihl,
	"tos", $tos,
	"totlen", $tot,
	"id", $id,
	"fragoff", $frg,
	"ttl", $ttl,
	"protocol", $pro,
	"proto", $prt,
	"check1", $chc,
	"rawsaddr", $saddr,
	"rawdaddr", $daddr,
	"sport", $sport,
	"dport", $dport,
	"sequence", $seq,
	"seq", $seq,
	"ackseq", $aseq,
	"doff", $dof,
	"res1", $res1,
	"res2", $res2,
	"urg", $urg,
	"ack", $ack,
	"psh", $psh,
	"rst", $rst,
	"syn", $syn,
	"fin", $fin,
	"winsize", $win,
	"check2", $chk,
	"data", $data,
	"time", $tm,
	"headers", $headers,
   );
   if ($string{"data"} =~ /^\s*?$/) {
    $string{"data"} = "";
   }
   $string{"seq"} =~ s/^-//;
   $string{"sequence"} =~ s/^-//;
   $string{"ackseq"} =~ s/^-//;
   $nstrg =~ s/\\t/\t/g;
   $nstrg =~ s/\\n/\n/g;
   $nstrg =~ s/\$([A-Za-z0-9]+)/$string{$1}/g;
   unless ($str =~ /^[\s\\]*\$data[\s\\]*$/ and $data =~ /^\s*$/) {
    print "$nstrg\n";
   }
  }
  else {
   unless ($ansi) {
    print "\r";
    if ($tstm != 1 and $tstm != 2) {
     print strftime "%H:%M:%S", localtime;
     print ".$time ";
    }
    if ($tstm == 2) {
     print "$untm.$time ";
    }
    print "$sname.$stype > $dname.$dtype: ";
    if ($headers) {
#     if ($ack) {
#      print "A";
#     }
     print "$headers ";
    }
#    if ($urg) {
#     print "$prg ";
#    }
    if ($seq) {
     print "$seq";
    }
    if ($ack) {
     $aseq =~ s/^-//;
     print " ack $aseq"
    }
    if (defined($win)) {
     print " win $win";
    }
    print $df;
    if ($tos != 0) {
     print " [tos 0x";
     $nts = sprintf("%x", unpack("C", $tos));
#     $nts = sprintf("%x", ord($tos));
     print "$nts]";
    }
    print " ($proto";
    if ($verb) {
     print " ttl $ttl, id $id";
    }
    print ")";
    if ($hexa) {
     my (@nda, @ndb, $totl);
     ($ndata = $data) =~ s/(.{1})/sprintf("%x", unpack("C", $1))/eg;
     ($ndatb = $data) =~ s/(.{16})/$1\n/g;
     $ndata =~ s/(\w{32})/$1\n/g;
     @nda = split(/\n/, $ndata);
     @ndb = split(/\n/, $ndatb);
     for ($i = 0; $i < @nda; $i++) {
      my $totl;
      if ($nda[0] and $i == 0) {
       print "\n";
      }
      $y = 0 x (3 - length($i)) . $i . 0;
      $nda[$i] =~ s/(\w{4})/ $1/g;
      $ndb[$i] =~ s/\s{1}/./g;
      while ($ndb[$i] =~ /(.{1})/g) {
       $tprv = $1;
       $ttmp = sprintf("%x", unpack("C", $tprv));
       if ($ttmp !~ /^[0-7]{1}/) {
        $totl .= ".";
       }
       else {
        $totl .= $tprv;
       }
      }
#      print "0x$y\t$nda[$i]\t$ndb[$i]\n";
      if ($nda[$i+1]) {
       print "0x$y\t$nda[$i]\t$totl\n";
      }
      else {
       print "0x$y\t$nda[$i]\t$totl";
      }
     }
    }
    if ($hex and !$hexa) {
     if ($data) {
      print "\n";
      ($ndata = $data) =~ s/(.{1})/sprintf("%x", unpack("C", $1))/eg;
      $ndata =~ s/(\w{32})/\t\t\t $1\n/g;
#      if (($tmpr) = $ndata =~ /\n([^\s]+.*?)$/) {
#       $ndata =~ s/\n$r$/\n\t\t\t $r\n/;
#      }
      $ndata =~ s/(\w{4})/$1 /g;
      $ndata =~ s/\n(\S+)/\n\t\t\t $1/;
      $ndata =~ s/^(\S+)/\t\t\t $1/;
      $ndata =~ s/\s+\w{1}$/ /;
      print $ndata;
     }
    }
   }
   else {
    $hr = strftime "%H", localtime;
    $min = strftime "%M", localtime;
    $sec = strftime "%S", localtime;
    print "\r";
    if ($tstm == 2) {
     print colored($untm, $hour);
     print colored(".", $dot1);
     print colored($time, $millisecond);
     print " ";
    }
    if ($tstm != 1 and $tstm != 2) {
     print colored($hr, $hour);
     print colored(":", $semicolon1);
     print colored($min, $minute);
     print colored(":", $semicolon2);
     print colored($sec, $second);
     print colored(".", $dot1);
     print colored($time, $millisecond);
     print " ";
    }
    print colored($sname, $source_ip);
    print colored(".", $dot2);
    print colored($stype, $source_port);
    print " ";
    print colored(">", $to);
    print " ";
    print colored($dname, $destination_ip);
    print colored(".", $dot3);
    print colored($dtype, $destination_port);
    print colored(":", $semicolon3);
    if ($headers) {
     print " ";
#     if ($ack) {
#      print colored("A", $headers2);
#     }
     print colored($headers, $headers2);
    }
    if ($seq) {
     print " ";
     print colored($seq, $sequence);
    }
    print " ";
#    if ($urg) {
#     print colored($prg, $urg_ptr);
#     print " ";
#    }
    if ($ack) {
     $aseq =~ s/^-//;
     print colored("ack", $ack2);
     print " ";
     print colored($aseq, $ack_number);
     print " ";
    }
    if (defined($win)) {
     print colored("win", $win2);
     print " ";
     print colored($win, $window_size);
    }
    print $df;
    if (defined($win)) {
     print " ";
    }
    if ($tos != 0) {
     print colored("[tos 0x", $tsc);
#     $nts = sprintf("%x", unpack("C", $tos));
     $nts = $tos;
     $nts =~ s/(.{2})/sprintf("%x",ord($1))/eg;
     print colored("$nts] ", $tsc);
    }
    print colored("(", $paren3);
    print colored($proto, $tcp);
    if ($verb) {
     print " ";
     print colored("ttl", $tmtl);
     print " ";
     print colored($ttl, $tttl);
     print colored(",", $comma);
     print " ";
     print colored("id", $idc);
     print " ";
     print colored($id, $tidc);
    }
    print colored(")", $paren4);
    if ($hex and !$hexa) {
     if ($data) {
      print "\n";
      ($ndata = $data) =~ s/(.{1})/sprintf("%x", unpack("C", $1))/eg;
      $ndata =~ s/(\w{32})/\t\t\t $1\n/g;
      if (($tmpr) = $ndata =~ /\n(\w+)$/) {
       $ndata =~ s/\n$r$/\n\t\t\t $r\n/;
      }
      $ndata =~ s/(\w{4})/$1 /g;
      print $ndata;
     }
    }
   }
   print "\n";
  }
  if ($amt and $top == $amt) {
   die "\r$amt packets recieved by filter\n";
  }
 }
}

1;
